import os
import shutil
import tarfile
import tempfile


def rebuild_tarball(src_tarball, version, target_dir):
    src_name = src_tarball.split('.')[0]
    new_tarball_dir = "{}-{}".format(src_name, version)

    # Pull out original sources to tarfix_dir
    orig_tarball = tarfile.open(name=src_tarball, mode="r:gz")
    tarfix_dir = tempfile.mkdtemp(suffix="tarfix")
    orig_tarball.extractall(path=tarfix_dir)
    orig_tarball.close()

    # Fix the directory with proper version
    shutil.move("{0}/{1}".format(tarfix_dir, src_name),
                "{0}/{1}".format(tarfix_dir, new_tarball_dir))
    new_tarball = shutil.make_archive(base_name=os.path.join(target_dir,
                                                             new_tarball_dir),
                                      format="gztar",
                                      base_dir=new_tarball_dir,
                                      root_dir=tarfix_dir)
    shutil.rmtree(tarfix_dir)

    return new_tarball
